#include <MHZ19.h>
#include <SoftwareSerial.h>

int MHZ_TX_PIN = 9;  // TX Pin von MH-Z19B
int MHZ_RX_PIN = 10; // RX Pin von MH-Z19B

// Objekt für den Sensor
MHZ19 co2Sensor;
// Objekt für die Kommunikation mit dem Sensor.
// Verbine Arduino RX mit MH-Z19B TX und
// Arduino TX mit MH-Z19B RX.
SoftwareSerial co2Serial(MHZ_TX_PIN, MHZ_RX_PIN);

unsigned long timeElapse = 0;

void setup()
{
  // Starte serielle Schnittstelle zur Kommunikation mit dem Arduino
  Serial.begin(9600);
  // Starte Kommunikationsschnittstelle für den Co2 Sensor
  co2Serial.begin(9600);
  // Starte den Sensor mit der Kommunikationsschnittstelle
  co2Sensor.begin(co2Serial);
  // Schalte automatische Kalibration ab
  co2Sensor.autoCalibration(false);

  Serial.print("ABC Status: ");
  if (co2Sensor.getABC()) {
    Serial.println("ON");
  } else {
    Serial.println("OFF");
  }

  Serial.println("Warte 20 Minuten, damit sich der Wert stabilisiert...");
  timeElapse = 12e5;                    //  20 Minuten in Millisekunden
  while (millis() < timeElapse) {};     //  Warte die 20 Minuten

  Serial.println("Kalibiere...");
  co2Sensor.calibrate();    // Kalibiere den Sensor indem der derzeite Wert als 400ppm Basis genommen wird.
  Serial.println("...abgeschlossen!");

  Serial.print("CO2 (ppm): ");
  Serial.println(co2Sensor.getCO2());

  Serial.println("Sensor kann nun entfernt werden.");
}

void loop(){
}
